unit Input;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Grids, Buttons;

type
  TInputWindow = class(TForm)
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    RadioGroup2: TRadioGroup;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RadioGroup1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button1Click(Sender: TObject);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure FormCreate(Sender: TObject);
  private
  public
    procedure UpdateCols;
  end;

type Params=record
  Mode: Integer;
  FileName: String;
  MinMax: Integer;
  X: Integer;
  n: Integer;
  A: array[1..10, 1..10] of Integer;
  B: array[1..10] of Integer;
end;

var
  InputWindow: TInputWindow;
  Data: Params;

implementation

uses Main;

{$R *.DFM}

procedure TInputWindow.UpdateCols;
  var S: String;
      i: Integer;
begin
  for i:=0 to UpDown1.Position-1 do begin
    Str(i+1, S);
    S:='X'+S;
    StringGrid1.Cells[i, 0]:=S;
    StringGrid2.Cells[i, 0]:=S;
  end;
  for i:=0 to UpDown1.Position+2 do begin
    Str(i+1, S);
    S:='X'+S;
    MainForm.StringGrid1.Cells[i, 0]:=S;
    MainForm.StringGrid2.Cells[i+1, 0]:=S;
  end;
  StringGrid1.Cells[UpDown1.Position, 0]:='F0';
  MainForm.StringGrid1.Cells[UpDown1.Position+3, 0]:='F0';
end;

procedure TInputWindow.FormShow(Sender: TObject);
  var i, j: Integer;
begin
  RadioGroup1.ItemIndex:=Data.Mode;
  OpenDialog1.FileName:=Data.FileName;
  RadioGroup2.ItemIndex:=Data.MinMax;
  UpDown1.Position:=Data.X;
  UpDown2.Position:=Data.n;
  for i:=0 to Data.X do begin
    for j:=1 to Data.n do
      StringGrid1.Cells[i, j]:=IntToStr(Data.A[i+1, j]);
    StringGrid2.Cells[i, 1]:=IntToStr(Data.B[i+1]);
  end;
  MainForm.Enabled:=False;
end;

procedure TInputWindow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MainForm.Enabled:=True;
end;

procedure TInputWindow.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex=1 then begin
    Button1.Enabled:=True;
    Button1Click(Button1);
  end
    else Button1.Enabled:=False;
end;

procedure TInputWindow.BitBtn1Click(Sender: TObject);
  var i, j: Integer;
begin
  Data.Mode:=RadioGroup1.ItemIndex;
  Data.FileName:=OpenDialog1.FileName;
  Data.MinMax:=RadioGroup2.ItemIndex;
  Data.X:=UpDown1.Position;
  Data.n:=UpDown2.Position;
  for i:=0 to Data.X do begin
    for j:=1 to Data.n do
      if StringGrid1.Cells[i, j]='' then
        MessageDlg('  ', mtWarning, [mbOk], 0)
      else
        Data.A[i+1, j]:=StrToInt(StringGrid1.Cells[i, j]);
    if StringGrid2.Cells[i, 1]='' then
      MessageDlg('  ', mtWarning, [mbOk], 0)
    else
      Data.B[i+1]:=StrToInt(StringGrid2.Cells[i, 1]);
  end;
  MainForm.StringGrid1.ColCount:=Data.X+4;
  MainForm.StringGrid1.RowCount:=Data.n+1;
  MainForm.StringGrid2.ColCount:=Data.X+4;
  MainForm.InitVars;
  MainForm.BitBtn1.Enabled:=True;
  Close;
end;

procedure TInputWindow.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TInputWindow.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  StringGrid1.ColCount:=UpDown1.Position+1;
  StringGrid2.ColCount:=UpDown1.Position;
  UpdateCols;
end;

procedure TInputWindow.Button1Click(Sender: TObject);
begin
  OpenDialog1.Execute;
end;

procedure TInputWindow.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  StringGrid1.RowCount:=UpDown2.Position+1;
  UpdateCols;
end;

procedure TInputWindow.FormCreate(Sender: TObject);
begin
  Data.Mode:=0;
  Data.FileName:='input.txt';
  Data.MinMax:=1;
  Data.X:=4;
  Data.n:=3;
end;

end.
