
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, StdCtrls, Buttons, ExtCtrls;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    GroupBox1: TGroupBox;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure N1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    procedure PrintData;
    procedure Ea;
    procedure Kl_stst;
    procedure Divider;
    procedure CheckZero(Zero: Real);
  public
    procedure InitVars;
  end;

var
  MainForm: TMainForm;
  a1: array[1..13] of Real;
  a3: array[1..13, 1..10] of Real;
  A0: array[1..10] of Real;
  Xb: array[1..10] of Real;
  Cb: array[1..10] of Real;
  a7: Real;
  a8: array[1..13] of Real;
  E:  array[1..10] of Real;
  a:  array[1..10] of Real;
  i, j, k, Kl_st, Kl_str: Integer;
  X, Y: Integer;
  n: Integer;

implementation

uses Input, About;

{$R *.DFM}

procedure TMainForm.CheckZero(Zero: Real);
begin
  if Zero=0 then begin
    MessageDlg('Application error. Devide by zero', mtError, [mbOk], 0);
    Close;
  end;
end;

procedure TMainForm.InitVars;
begin
  X:=Input.Data.X;
  Y:=Input.Data.n;
  for i:=1 to X do begin
    for j:=1 to Y do
      a3[i, j]:=Input.Data.A[i, j];
    a1[i]:=Input.Data.B[i];
  end;

  for j:=1 to Y do
    a0[j]:=Input.Data.A[5, j];

  for i:=X+1 to X+3 do begin
    for j:=1 to Y do begin
      a3[i, j]:=0;
      a3[j+4, j]:=1;
    end;
    a8[i]:=0;
    a1[i]:=0;
    Cb[i-4]:=0;
  end;

  for i:=1 to X do
    a8[i]:=-a1[i];

end;

procedure TMainForm.PrintData;
  var S: String;
begin
  for i:=1 to X+3 do begin
    for j:=1 to Y do begin
      Str(a3[i, j]:4:2, S);
      StringGrid1.Cells[i-1, j]:=S;
    end;
    Str(a8[i]:4:2, S);
    StringGrid2.Cells[i, 1]:=S;
  end;
  StringGrid2.Cells[0, 1]:=InputWindow.RadioGroup2.Items[Data.MinMax]+'=';
  for j:=1 to Y do begin
    Str(A0[j]:4:2, S);
    StringGrid1.Cells[7, j]:=S;
  end;
end;

procedure TMainForm.Ea;
begin
  for j:=1 to Y do begin
    E[j]:=0;
    for i:=1 to X+4 do
      if (i<>X+4) then
        E[j]:=E[j]+a3[i, j]
      else
        E[j]:=E[j]+A0[j];
    if
      a3[Kl_st][j]=0 then a[j]:=-1
    else begin
      CheckZero(a3[Kl_st][j]);
      a[j]:=A0[j]/a3[Kl_st][j];
    end;
  end;
end;

procedure TMainForm.Kl_stst;
  var m: Real;
begin
  m:=a8[1];
  Kl_st:=1;

  for i:=1 to X+3 do
    if a8[i]<m then begin
      m:=a8[i];
      Kl_st:=i;
    end;
  Ea;

  if a[1]<0 then begin
    m:=a[2];
    Kl_str:=2;
  end
  else begin
    Kl_str:=1;
    m:=a[1];
  end;

  for j:=2 to Y do begin
    if (a[j]<m) and (a[j]>0) then begin
      m:=a[j];
      Kl_str:=j;
    end;
  end;
end;

procedure TMainForm.Divider;
  var f1, f2, f3, f4: Real;
begin
  for j:=1 to Y do
    if j<>Kl_str then begin
      for i:=1 to X+3 do
        if i<>Kl_st then begin
          f1:=a3[i, j];
          f2:=a3[i, Kl_str];
          f3:=a3[Kl_st, j];
          f4:=a3[Kl_st, Kl_str];
          CheckZero(f4);
          a3[i, j]:=f1-(f2*f3)/f4;
        end;
        CheckZero(a3[Kl_st, Kl_str]);
        A0[j]:=A0[j]-(A0[Kl_str]*a3[Kl_st, j])/a3[Kl_st, Kl_str];
    end;
  for i:=1 to X+3 do
    if i<>Kl_st then begin
      CheckZero(a3[Kl_st, Kl_str]);
      a8[i]:=a8[i]-(a3[i, Kl_str]*a8[Kl_st])/a3[Kl_st, Kl_str];
      f1:=a3[i, Kl_str];
      f4:=a3[Kl_st, Kl_str];
      CheckZero(f4);
      a3[i, Kl_str]:=f1/f4;
    end;
    CheckZero(a3[Kl_st, Kl_str]);
    A0[Kl_str]:=A0[Kl_str]/a3[Kl_st, Kl_str];
  for j:=1 to Y do
    a3[Kl_st, j]:=0;
    a3[Kl_st, Kl_str]:=1;
    a8[Kl_st]:=0;
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  InputWindow.Show;
end;

procedure TMainForm.N4Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  InputWindow.UpdateCols;
end;

procedure TMainForm.N5Click(Sender: TObject);
begin
  AboutBox.Show;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  Kl_stst;
  Divider;
  PrintData;
  Inc(n);
  Panel1.Caption:=IntToStr(n);
  j:=0;
  for i:=1 to X+3 do begin
    if Input.Data.MinMax=0 then
      if a8[i]>0 then j:=1;
    if Input.Data.MinMax=1 then
      if a8[i]<0 then j:=1;
  end;

  if j=0 then Panel2.Caption:=' '
    else Panel2.Caption:='  ';
end;


end.
