unit IO;

interface

uses Views, Drivers, Dialogs, Objects, Validate;

type
  PIOWindow=^TIOWindow;
  TIOWindow=object(TDialog)
    constructor Init(X, Y: Byte; Caption: String);
  end;

  PInputData=^TInputData;
  TInputData=record
    S: array[1..20] of String[3];
  end;

  POutputData=^TOutputData;
  TOutputData=record
    S: array[1..21] of String[3];
  end;

implementation

constructor TIOWindow.Init(X, Y: Byte; Caption: String);
  var R: TRect;
      i, j: Byte;
      P: PInputLine;
      Control: PView;
      S: String;
begin
  j:=Y*2+6;
  i:=X*7+16;
  R.Assign(0, 0, i, j);
  inherited Init(R, Caption);

  R.Assign(2, j-3, 12, j-1);
  Control:=New(PButton, Init(R, '~O~K', 10, 0));
  Insert(Control);

  if Caption=' ' then begin
    R.Assign(14, j-3, 24, j-1);
    Control:=New(PButton, Init(R, '~~', 11, 0));
    Insert(Control);
  end;

  for i:=0 to X-1 do begin
    Str(i+1, S);
    R.Assign(i*7+15, 2, i*7+20, 3);
    Control:=New(PLabel, Init(R, 'X'+S, nil));
    Insert(Control);
  end;

  for j:=0 to Y-1 do begin
    Str(j+1, S);
    R.Assign(2, j*2+3, 15, j*2+4);
    if j<Y-1 then begin
      Control:=New(PLabel, Init(R, S+' ࠢ', nil));
      Insert(Control);
    end;
    for i:=0 to X-1 do begin
      R.Assign(i*7+15, j*2+3, i*7+20, j*2+4);
      P:=New(PInputLine, Init(R, 3));
      P^.SetValidator(New(PRangeValidator, Init(-100, 100)));
      Insert(P);
    end;
  end;

  R.Assign(2, Y*2+1, 15, Y*2+2);
  Control:=New(PLabel, Init(R, '㭪 F', nil));
  Insert(Control);

  Options:=Options or ofCentered;
end;

end.
