unit Output;

interface

uses Views, Drivers, Dialogs, Objects, Validate;

type
  POutputWindow=^TOutputWindow;
  TOutputWindow=object(TDialog)
    constructor Init(MatrixSize: Byte);
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  POutputData=^TOutputData;
  TOutputData=record
    S: array[1..21] of String[3];
  end;

implementation

constructor TOutputWindow.Init(MatrixSize: Byte);
  var R: TRect;
      X, Y, i, j: Byte;
      P: PInputLine;
      Control: PView;
      S: String;

begin
  asm
    mov al, MatrixSize
    shr al, 4
    mov X, al
    mov al, MatrixSize
    and al, 15
    mov Y, al
  end;

  j:=y*2+6;
  i:=X*7+16;
  R.Assign(0, 0, i, j);
  inherited Init(R, '뢮 ');

  R.Assign(i-13, j-3, i-3, j-1);
  Control:=New(PButton, Init(R, '~O~K', 10, 0));
  Insert(Control);

  for i:=0 to X-1 do begin
    Str(i+1, S);
    R.Assign(i*7+15, 2, i*7+20, 3);
    Control:=New(PLabel, Init(R, 'X'+S, nil));
    Insert(Control);
  end;

  for j:=0 to Y-1 do begin
    Str(j+1, S);
    R.Assign(2, j*2+3, 15, j*2+4);
    if j<Y-1 then begin
      Control:=New(PLabel, Init(R, S+' ࠢ', nil));
      Insert(Control);
    end;
    for i:=0 to X-1 do begin
      R.Assign(i*7+15, j*2+3, i*7+20, j*2+4);
      P:=New(PInputLine, Init(R, 3));
      P^.SetValidator(New(PFilterValidator, Init(['0'..'9'])));
      Insert(P);
    end;
  end;

  R.Assign(2, Y*2+1, 15, Y*2+2);
  Control:=New(PLabel, Init(R, '㭪 F', nil));
  Insert(Control);

  Options:=Options or ofCentered;
end;

procedure TOutputWindow.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What=evBroadcast) and (Event.Command=1114) then
    ClearEvent(Event);
end;

end.
