unit Setup;

interface

uses Views, Drivers, Dialogs, Objects;

type
  PSetupDialog=^TSetupDialog;
  TSetupDialog=object(TDialog)
    constructor Init;
    procedure HandleEvent(var Event: TEvent); virtual;
    destructor Done; virtual;
  end;

  PData=^TData;
  TData=record
    Name: String[8];
    OutMode: Word;
    OutName: String[8];
    Size: Word;
    F: Word;
    Mode: Word;
  end;

implementation

constructor TSetupDialog.Init;
  var P: PView;
      R: TRect;
begin
  R.Assign(0, 0, 60, 14);
  inherited Init(R, 'ன');
  Options:=Options or ofCentered;

  R.Assign(3, 7, 21, 8);
  P:=New(PInputLine, Init(R, 8));
  Insert(P);

  R.Assign(2, 6, 21, 7);
  P:=New(PLabel, Init(R, ' 䠩 (*.TXT):', P));
  Insert(P);

  R.Assign(23, 3, 41, 5);
  P:=New(PRadioButtons, Init(R,
    NewSItem(' ࠭',
    NewSItem(' 䠩', nil))));
  Insert(P);

  R.Assign(22, 2, 36, 3);
  P:=New(PLabel, Init(R, '뢮 ', P));
  Insert(P);

  R.Assign(23, 7, 41, 8);
  P:=New(PInputLine, Init(R, 8));
  Insert(P);

  R.Assign(22, 6, 41, 7);
  P:=New(PLabel, Init(R, ' 䠩 (*.TXT):', P));
  Insert(P);

  R.Assign(43, 3, 57, 8);
  P:=New(PRadioButtons, Init(R,
    NewSItem('5 X 3',
    NewSItem('4 X 3',
    NewSItem('5 X 2',
    NewSItem('3 X 3',
    NewSItem('3 X 4', nil)))))));
  Insert(P);

  R.Assign(42, 2, 57, 3);
  P:=New(PLabel, Init(R, ' ', P));
  Insert(P);

  R.Assign(20, 9, 41, 10);
  P:=New(PRadioButtons, Init(R,
    NewSItem('Fmin',
    NewSItem('Fmax', nil))));
  Insert(P);

  R.Assign(2, 9, 21, 10);
  P:=New(PLabel, Init(R, ' 㭪', P));
  Insert(P);

  R.Assign(19, 11, 29, 13);
  P:=New(PButton, Init(R, '~O~K', 10, 0));
  Insert(P);

  R.Assign(30, 11, 40, 13);
  P:=New(PButton, Init(R, '~~', 11, 0));
  Insert(P);

  R.Assign(3, 3, 21, 5);
  P:=New(PRadioButtons, Init(R,
    NewSItem(' ',
    NewSItem(' 䠩', nil))));
  Insert(P);

  R.Assign(2, 2, 17, 3);
  P:=New(PLabel, Init(R, ' ', P));
  Insert(P);
end;

destructor TSetupDialog.Done;
begin
  inherited Done;
end;

procedure TSetupDialog.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What=evBroadcast) and (Event.Command=1112) then
    ClearEvent(Event);
end;

end.